<template>
  <div class="p-2">
    <transition :enter-active-class="proxy?.animate.searchAnimate.enter"
      :leave-active-class="proxy?.animate.searchAnimate.leave">
      <div v-show="showSearch" class="mb-[10px]">
        <el-card shadow="hover">
          <el-form ref="queryFormRef" :model="queryParams" :inline="true" label-width="100px">
            <el-form-item label="项目名称" prop="name">
              <el-input v-model="queryParams.name" placeholder="请输入项目名称" clearable @keyup.enter="handleQuery" />
            </el-form-item>
            <el-form-item label="项目编号" prop="projectSn">
              <el-input v-model="queryParams.projectSn" placeholder="请输入项目编号" clearable @keyup.enter="handleQuery" />
            </el-form-item>
            <el-form-item>
              <el-button type="primary" icon="Search" @click="handleQuery"> 搜索 </el-button>
              <el-button icon="Refresh" @click="resetQuery"> 重置 </el-button>
            </el-form-item>
          </el-form>
        </el-card>
      </div>
    </transition>

    <el-card shadow="never">
      <template #header>
        <el-row :gutter="10" class="mb8">
          <el-col :span="1.5">
            <el-button type="primary" plain icon="Plus" @click="handleAdd"> 新增 </el-button>
          </el-col>
          <el-col :span="1.5">
            <el-button type="success" plain icon="Edit" :disabled="single" @click="handleUpdate"> 修改
            </el-button>
          </el-col>
          <el-col :span="1.5">
            <el-button type="danger" plain icon="Delete" :disabled="multiple" @click="handleDelete"> 删除
            </el-button>
          </el-col>
          <right-toolbar v-model:showSearch="showSearch" @query-table="getList" />
        </el-row>
      </template>

      <el-table v-loading="loading" :data="tableList" @selection-change="handleSelectionChange">
        <el-table-column type="selection" width="55" align="center" />
        <el-table-column label="项目编号" align="center" show-overflow-tooltip prop="projectSn" width="150" />
        <el-table-column label="项目名称" align="center" show-overflow-tooltip prop="name" width="150" />
        <el-table-column label="项目负责人" align="center" show-overflow-tooltip prop="ext1.leaderName" width="150" />
        <el-table-column label="联系电话" align="center" show-overflow-tooltip prop="ext1.phone" width="150" />
        <el-table-column label="开始日期" align="center" show-overflow-tooltip prop="ext1.startDate" width="150" />
        <el-table-column label="结束日期" align="center" show-overflow-tooltip prop="ext1.endDate" width="150" />
        <el-table-column label="监理" align="center" show-overflow-tooltip prop="ext1.supervisor" width="150" />
        <el-table-column label="设计单位" align="center" show-overflow-tooltip prop="ext1.designerCompany" width="150" />
        <el-table-column label="承建单位" align="center" show-overflow-tooltip prop="ext1.buildCompany" width="150" />
        <el-table-column label="操作" align="center" width="150" fixed="right" class-name="small-padding fixed-width">
          <template #default="scope">
            <el-button size="small" link type="primary" @click="handleUpdate(scope.row)">修改</el-button>
            <el-button size="small" link type="primary" @click="bindDevice(scope.row)">绑定设备</el-button>
            <el-button size="small" link type="danger" @click="handleDelete(scope.row)">删除</el-button>
          </template>
        </el-table-column>
      </el-table>
      <pagination v-show="total > 0" v-model:page="queryParams.pageNum" v-model:limit="queryParams.pageSize"
        :total="total" @pagination="getList" />
    </el-card>
    <!-- 添加或修改对话框 -->
    <el-dialog v-model="dialog.visible" :title="dialog.title" width="900px" append-to-body>
      <el-form ref="addFormRef" :model="form" label-width="120px">
        <el-row :gutter="20">
          <el-col :span="12">
            <el-form-item label="项目名称" prop="name" :rules="[{ required: true, message: '项目名称不能为空', trigger: 'blur' }]">
              <el-input v-model="form.name" placeholder="请输入项目名称" />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="项目编号" prop="projectSn" :rules="[{ required: true, message: '项目编号不能为空', trigger: 'blur' }]">
              <el-input v-model="form.projectSn" placeholder="请输入项目编号" />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="项目负责人" prop="leaderId"
              :rules="[{ required: true, message: '项目负责人不能为空', trigger: 'change' }]">
              <el-select v-model="form.leaderId" clearable @change="setUserInfo">
                <el-option v-for="item in userList" :key="item.userId" :label="item.nickName"
                  :value="item.userId"></el-option>
              </el-select>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="联系电话" prop="ext1.phone">
              <el-input v-model="form.ext1.phone" disabled placeholder="根据项目负责人带出" />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="开始时间" prop="ext1.startDate">
              <el-date-picker v-model="form.ext1.startDate" style="width: 100%;" value-format="YYYY-MM-DD" type="date" placeholder="请选择开始时间" />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="结束时间" prop="ext1.endDate">
              <el-date-picker v-model="form.ext1.endDate" style="width: 100%;" value-format="YYYY-MM-DD" type="date" placeholder="请选择结束时间" />
            </el-form-item>
          </el-col>
          <el-col :span="24">
            <el-form-item label="监理单位" prop="ext1.supervisorCompany">
              <el-input v-model="form.ext1.supervisorCompany" placeholder="请输入监理单位" />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="监理姓名" prop="ext1.supervisor">
              <el-input v-model="form.ext1.supervisor" placeholder="请输入监理姓名" />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="联系电话" prop="ext1.supervisorPhone">
              <el-input v-model="form.ext1.supervisorPhone" placeholder="请输入联系电话" />
            </el-form-item>
          </el-col>
          <el-col :span="24">
            <el-form-item label="设计单位" prop="ext1.designerCompany">
              <el-input v-model="form.ext1.designerCompany" placeholder="请输入设计单位" />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="设计单位负责人" prop="ext1.designer">
              <el-input v-model="form.ext1.designer" placeholder="请输入设计单位负责人" />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="联系电话" prop="ext1.designerPhone">
              <el-input v-model="form.ext1.designerPhone" placeholder="请输入联系电话" />
            </el-form-item>
          </el-col>
          <el-col :span="24">
            <el-form-item label="承建单位" prop="ext1.buildCompany">
              <el-input v-model="form.ext1.buildCompany" placeholder="请输入承建单位" />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="施工承建负责人" prop="ext1.buildLeader">
              <el-input v-model="form.ext1.buildLeader" placeholder="请输入施工承建负责人" />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="联系电话" prop="ext1.buildLeaderPhone">
              <el-input v-model="form.ext1.buildLeaderPhone" placeholder="请输入联系电话" />
            </el-form-item>
          </el-col>
          <el-col :span="24">
            <el-form-item label="项目说明" prop="remark">
              <el-input v-model="form.remark" type="textarea" placeholder="请输入项目说明" />
            </el-form-item>
          </el-col>
        </el-row>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button :loading="buttonLoading" type="primary" @click="submitForm"> 确 定 </el-button>
          <el-button @click="cancel"> 取 消 </el-button>
        </div>
      </template>
    </el-dialog>
    <el-dialog v-model="deviceDialog" title="选择设备" width="750px" append-to-body>
      <el-table ref="deviceTableRef" :data="deviceList" @selection-change="deviceSelectionChange">
        <el-table-column type="selection" width="55" align="center" />
        <el-table-column label="设备编号" align="center" prop="sn" />
        <el-table-column label="设备名称" align="center" prop="name" />
        <el-table-column label="设备位置" align="center" show-overflow-tooltip prop="ext1.address" />
      </el-table>
      <template #footer>
        <div class="dialog-footer">
          <el-button :loading="buttonLoading" type="primary" @click="deviceConfirm"> 确 定 </el-button>
          <el-button @click="deviceDialog = false"> 取 消 </el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="Project" lang="ts">
import { listProjectInfo, getProjectInfo, delProjectInfo, addProjectInfo, updateProjectInfo } from '@/api/projectManage/index';
import { listUser } from '@/api/system/user/index'
import { listDevice } from '@/api/deviceManage/device';
import { deepClone } from '@/utils';
const { proxy } = getCurrentInstance() as ComponentInternalInstance;
const tableList = ref([]);
const buttonLoading = ref(false);
const loading = ref(true);
const showSearch = ref(true);
const ids = ref<Array<string | number>>([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);
const queryFormRef = ref<ElFormInstance>();
const addFormRef = ref<ElFormInstance>();
const deviceTableRef = ref<ElTableInstance>();
const dialog = reactive<DialogOption>({
  visible: false,
  title: ''
});
const userList = ref([]);
const deviceDialog = ref(false)
const deviceList = ref([])
const deviceSelectedIds = ref([])
const initFormData = {
  id: undefined,
  name: undefined,
  projectSn: undefined,
  num: undefined,
  leaderId: undefined,
  files: undefined,
  devices: undefined,
  remark: undefined,
  ext1: <any>{
    leaderName:'',
    phone: '',
    startDate: '',
    endDate: '',
    supervisorCompany: '',
    supervisor: '',
    supervisorPhone: '',
    designerCompany: '',
    designer: '',
    designerPhone: '',
    buildCompany: '',
    buildLeader: '',
    buildLeaderPhone: '',
  },
  ext2: undefined
};
const formData = reactive({
  form: { ...initFormData },
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    name: undefined,
    projectSn: undefined,
    params: {}
  }
});

const { queryParams, form } = toRefs(formData);
const dictGroup = reactive({
  deviceTypeDetailOptions: []
})
/** 查询列表 */
const getList = async () => {
  loading.value = true;
  const res = await listProjectInfo(queryParams.value);
  tableList.value = res.rows.map((item) => ({
    ...item,
    ext1: item.ext1 ? JSON.parse(item.ext1) : null,
  }));
  total.value = res.total;
  loading.value = false;
};

/** 取消按钮 */
const cancel = () => {
  reset();
  dialog.visible = false;
};

/** 表单重置 */
const reset = () => {
  form.value = { ...deepClone(initFormData) };
  addFormRef.value?.resetFields();
};

/** 搜索按钮操作 */
const handleQuery = () => {
  queryParams.value.pageNum = 1;
  getList();
};

/** 重置按钮操作 */
const resetQuery = () => {
  queryFormRef.value?.resetFields();
  handleQuery();
};

/** 多选框选中数据 */
const handleSelectionChange = (selection) => {
  ids.value = selection.map((item) => item.id);
  single.value = selection.length != 1;
  multiple.value = !selection.length;
};
/** 新增按钮操作 */
const handleAdd = () => {
  reset();
  dialog.visible = true;
  dialog.title = '新增项目';
};
/** 修改按钮操作 */
const handleUpdate = async (row) => {
  reset();
  const _id = row?.id || ids.value[0];
  const { data } = await getProjectInfo(_id);
  data.ext1 = data.ext1 && JSON.parse(data.ext1);
  Object.assign(form.value, data);
  dialog.visible = true;
  dialog.title = '修改项目';
};

/** 提交按钮 */
const submitForm = () => {
  addFormRef.value?.validate(async (valid: boolean) => {
    if (valid) {
      const { ext1 } = form.value;
      buttonLoading.value = true;
      const params = Object.assign({}, form.value, { ext1: JSON.stringify(ext1) });
      if (form.value.id) {
        await updateProjectInfo(params).finally(() => (buttonLoading.value = false));
      } else {
        await addProjectInfo(params).finally(() => (buttonLoading.value = false));
      }
      proxy?.$modal.msgSuccess('操作成功');
      dialog.visible = false;
      await getList();
    }
  });
};
/** 删除按钮操作 */
const handleDelete = async (row) => {
  const _ids = row?.id || ids.value;
  await proxy?.$modal.confirm('是否确认删除？').finally(() => (loading.value = false));
  await delProjectInfo(_ids);
  proxy?.$modal.msgSuccess('删除成功');
  await getList();
};
const getUserList = () => {
  listUser({ status: '0', pageSize: 10000, pageNum: 1 }).then(({ code, rows }) => {
    if (code === 200) {
      userList.value = rows
    }
  })
}
const setUserInfo = () => {
  form.value.ext1.phone = ''
  form.value.ext1.leaderName = ''
  const { leaderId } = form.value
  userList.value.forEach(item => {
    if (leaderId === item.userId) {
      form.value.ext1.phone = item.phonenumber
      form.value.ext1.leaderName = item.nickName
    }
  })
}
const deviceSelectionChange = (selection) => {
  deviceSelectedIds.value = selection.map((item) => item.id);
}
const bindDevice = (row) => {
  deviceDialog.value = true
  form.value = row
  const selectedDevices =row.devices||''
  nextTick(() => {
    if (deviceTableRef.value) {
      deviceTableRef.value.clearSelection();
      deviceList.value.forEach(item => {
        if (selectedDevices.includes(item.id)) {
          deviceTableRef.value.toggleRowSelection(item, true);
        }
      });
    }
  });
}
const deviceConfirm = async () => {
  if (deviceSelectedIds.value.length === 0) return proxy?.$modal.msgError('请勾选设备');
  const { ext1 } = form.value;
  buttonLoading.value = true;
  const params = Object.assign({}, form.value, { ext1: JSON.stringify(ext1), devices: deviceSelectedIds.value.join() });
  await updateProjectInfo(params).finally(() => (buttonLoading.value = false));
  proxy?.$modal.msgSuccess('操作成功');
  deviceDialog.value = false;
  await getList();
}
const getDeviceList = async () => {
  const { code, rows } = await listDevice({});
  if (code === 200) {
    deviceList.value = rows.map((item) => ({
      ...item,
      controlFuncs: item.controlFuncs !== '{}' ? JSON.parse(item.controlFuncs) : [],
      dataPoints: item.dataPoints !== '{}' ? JSON.parse(item.dataPoints) : [],
      events: item.events !== '{}' ? JSON.parse(item.events) : [],
      ext1: item.ext1 ? JSON.parse(item.ext1) : null
    }));;
  }
}
onMounted(() => {
  getList();
  getUserList();
  getDeviceList();
});
</script>
<style lang="scss" scoped></style>
